<?php
namespace Ak\Gdpr\Hydrator;

use Ak\Hydrator\ReadOnlyHydrator;
use Interop\Container\ContainerInterface;
use Zend\Hydrator\HydratorInterface;
use Zend\Hydrator\Strategy\DateTimeFormatterStrategy;
use Zend\ServiceManager\Factory\FactoryInterface;

/**
 * Stvara novu instancu hidratora za GdprConsent entitet.
 *
 * @package Ak\Gdpr\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/gdpr
 */
final class GdprConsentHydratorFactory implements FactoryInterface
{
    /**
     * Stvara hidrator.
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     *
     * @return HydratorInterface
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $hydrator = new ReadOnlyHydrator();
        $hydrator->addStrategy('time', new DateTimeFormatterStrategy('Y-m-d H:i:s'));

        return $hydrator;
    }
}